#ifndef _SYSTERMIOSH
#define _SYSTERMIOSH

typedef unsigned char cc_t;
typedef unsigned int speed_t;
typedef unsigned long tcflag_t;


#define NCC 8
struct termio {
	unsigned short c_iflag;		/* input mode flags */
	unsigned short c_oflag;		/* output mode flags */
	unsigned short c_cflag;		/* control mode flags */
	unsigned short c_lflag;		/* local mode flags */
	unsigned char c_line;		/* line discipline */
	unsigned char c_cc[NCC];	/* control characters */
};

#define NCCS 19
struct termios {
	tcflag_t c_iflag;		/* input mode flags */
	tcflag_t c_oflag;		/* output mode flags */
	tcflag_t c_cflag;		/* control mode flags */
	tcflag_t c_lflag;		/* local mode flags */
	cc_t c_line;			/* line discipline */
	cc_t c_cc[NCCS];		/* control characters */
};

/* c_cflag bit meaning */
#define  B0	0000000		/* hang up */
#define  B50	0000001
#define  B75	0000002
#define  B110	0000003
#define  B134	0000004
#define  B150	0000005
#define  B200	0000006
#define  B300	0000007
#define  B600	0000010
#define  B1200	0000011
#define  B1800	0000012
#define  B2400	0000013
#define  B4800	0000014
#define  B9600	0000015
#define  B19200	0000016
#define  B38400	0000017

/* c_cflag */
#define CLOCAL	0004000
#define CS5	0000000
#define CS6	0000020
#define CS7	0000040
#define CS8	0000060
#define CSIZE	0000060
#define CSTOPB	0000100
#define HUPCL	0002000
#define PARENB	0000400
#define PARODD	0001000

/* c_iflag bits */
#define BRKINT	0000002
#define ICRNL	0000400
#define IGNBRK	0000001
#define IGNCR	0000200
#define IGNPAR	0000004
#define INLCR	0000100
#define INPCK	0000020
#define ISTRIP	0000040
#define IXOFF	0010000
#define IXON	0002000
#define PARMRK	0000010


/* c_lflag bits */
#define ECHO	0000010
#define ECHOE	0000020
#define ECHOK	0000040
#define ECHONL	0000100
#define ICANON	0000002
#define IEXTEN	0100000
#define ISIG	0000001
#define NOFLSH	0000200
#define PENDIN	0040000
#define TOSTOP	0000400

/* c_oflag bits */
#define OPOST	0000001


/* c_cc characters */
#define VEOF      4
#define VEOL      11
#define VERASE    2
#define VINTR     0
#define VKILL     3
#define VMIN      6
#define VQUIT     1
#define VSTART    8
#define VSTOP     9
#define VSUSP    10
#define VTIME    5

/* c_cc characters for 4.3+BSD */
#define VDISCARD    13
#define VEOL2       16
#define VLNEXT      15
#define VREPRINT    12
#define VSWTC        7
#define VWERASE     14


/* tcflow() and TCXONC use these */
#define	TCOOFF		0
#define	TCOON		1
#define	TCIOFF		2
#define	TCION		3

/* tcflush() and TCFLSH use these */
#define	TCIFLUSH	0
#define	TCOFLUSH	1
#define	TCIOFLUSH	2

/* tcsetattr uses these */
#define	TCSANOW		0
#define	TCSADRAIN	1
#define	TCSAFLUSH	2

/* line disciplines */
#define N_TTY		0
#define N_SLIP		1
#define N_MOUSE		2
#define N_PPP		3

#endif
